Index: /trunk/SophyaLib/HiStats/histos2.h
===================================================================
--- /trunk/SophyaLib/HiStats/histos2.h	(revision 913)
+++ /trunk/SophyaLib/HiStats/histos2.h	(revision 914)
@@ -22,4 +22,24 @@
 class GeneralFit;
 
+
+/*!
+  Classe d'histogrammes 2D
+  \verbatim
+    Remarque sur les indices:
+     H(i,j)   -> i  = coord x (0<i<nx),     j  = coord y (0<j<ny)
+     v(ii,jj) -> ii = ligne (0<i<NRows()),  jj = colonne (0<i<NCol())
+     On fait une correspondance directe i<->ii et j<->jj
+     ce qui, en representation classique des histos2D et des matrices
+     entraine une inversion x<->y cad une symetrie / diagonale principale
+     H(0,...)  represente ^         mais v(0,...) represente
+                          |x.......               |xxxxxxxx|
+                          |x.......               |........|
+                          |x.......               |........|
+                          |x.......               |........|
+                          |x.......               |........|
+                          --------->
+                          colonne no 1            ligne no 1
+  \endverbatim
+*/
 class Histo2D : public AnyDataObj {
   friend class ObjFileIO<Histo2D>;
@@ -75,31 +95,52 @@
 
   // INLINES
+  //! Retourne l'abscisse minimum.
   inline float   XMin() const {return xmin;}
+  //! Retourne l'abscisse maximum.
   inline float   XMax() const {return xmax;}
+  //! Retourne l'ordonnee minimum.
   inline float   YMin() const {return ymin;}
+  //! Retourne l'ordonnee maximum.
   inline float   YMax() const {return ymax;}
+  //! Retourne le nombre de bins selon X.
   inline int_4   NBinX() const {return nx;}
+  //! Retourne le nombre de bins selon Y.
   inline int_4   NBinY() const {return ny;}
+  //! Retourne la largeur du bin selon X.
   inline float   WBinX() const {return wbinx;}
+  //! Retourne la largeur du bin selon Y.
   inline float   WBinY() const {return wbiny;}
+  //! Retourne le pointeur sur le tableaux des contenus.
   inline float*  Bins() const  {return data;}
+  //! Retourne le contenu du bin i,j.
   inline float   operator()(int i,int j) const {return data[j*nx+i];}
+  //! Remplit le contenu du bin i,j.
   inline float&  operator()(int i,int j)       {return data[j*nx+i];}
+  //! retourne "true" si il y a des erreurs stoquees
   inline bool    HasErrors() { if(err2) return true; else return false;}
+  //! Retourne l'erreur du bin i,j.
   inline float   Error(int i,int j)  const
                    {if(err2)
                       {if(err2[j*nx+i]>0.) return sqrt(err2[j*nx+i]); else return 0.;}
                     else return 0.;}
+  //! Remplit l'erreur au carre du bin i,j.
   inline double  Error2(int i,int j) const
                    {if(err2) return err2[j*nx+i]; else return 0.;}
+  //! Remplit l'erreur au carre du bin i,j.
   inline double& Error2(int i,int j) {return err2[j*nx+i];}
+  //! Retourne la somme ponderee.
   inline float   NData() const    {return (float) nHist;}
+  //! Retourne le nombre d'entrees.
   inline int_4   NEntries() const {return nEntries;}
+  //! Retourne l'abscisse et l'ordonnee du coin inferieur du bin i,j.
   inline void BinLowEdge(int i,int j,float& x,float& y)
                  {x = xmin + i*wbinx; y = ymin + j*wbiny;}
+  //! Retourne l'abscisse et l'ordonnee du centre du bin i,j.
   inline void BinCenter(int i,int j,float& x,float& y)
                  {x = xmin + (i+0.5)*wbinx; y = ymin + (j+0.5)*wbiny;}
+  //! Retourne l'abscisse et l'ordonnee du coin superieur du bin i,j.
   inline void BinHighEdge(int i,int j,float& x,float& y)
                  {x = xmin + (i+1)*wbinx; y = ymin + (j+1)*wbiny;}
+  //! Retourne les numeros du bin contenant l'abscisse et l'ordonnee x,y.
   inline void FindBin(float x,float y,int& i,int& j)
     { i = (int) floorf((x - xmin)/wbinx); j = (int) floorf((y - ymin)/wbiny);}
@@ -139,10 +180,14 @@
   void           ZeroProjY();
   void           ZeroProj();
+  //! Retourne le pointeur sur l'histo 1D de la projection selon X.
   inline Histo*  HProjX() const {return hprojx;}
+  //! Retourne le pointeur sur l'histo 1D de la projection selon Y.
   inline Histo*  HProjY() const {return hprojy;}
   void           ShowProj();
 
   // BANDES
+  //! Retourne le nombre de bandes selon X
   inline int     NBandX() const {return lbandx.size();}
+  //! Retourne le nombre de bandes selon Y
   inline int     NBandY() const {return lbandy.size();}
   int            SetBandX(float ybmin,float ybmax);
@@ -159,5 +204,7 @@
 
   // SLICES
+  //! Retourne le nombre de slices selon X
   inline int     NSliX() const {return lslix.size();}
+  //! Retourne le nombre de slices selon Y
   inline int     NSliY() const {return lsliy.size();}
   int            SetSliX(int nsli);
@@ -174,8 +221,10 @@
 protected:
 #endif
+  //! structure de definition des bandes
   struct bande_slice {
-    int num;
-    float min, max;
-    Histo* H;
+    int num;   //!< nombre de bandes
+    float min; //!< limite minimum pour remplir la bande
+    float max; //!< limite maximum pour remplir la bande
+    Histo* H;  //!< pointer sur l Histo 1D de la bande
     STRUCTCOMP(bande_slice)
   };
@@ -186,29 +235,31 @@
   void Delete();
 
-  float*         data;
-  double*        err2;
-
-  float          over[3][3];
-  double         nHist;
-  int_4          nEntries;
-
-  int_4          nx,ny,nxy;
-  float          xmin;
-  float          xmax;
-  float          ymin;
-  float          ymax;
-  float          wbinx;
-  float          wbiny;
+  float*         data; //!< donnees
+  double*        err2; //!< erreurs carrees
+
+  float          over[3][3]; //!< overflow table
+  double         nHist;      //!< somme ponderee des entrees
+  int_4          nEntries;   //!< nombre d'entrees
+
+  int_4          nx;    //!< nombre de bins en X
+  int_4          ny;    //!< nombre de bins en Y
+  int_4          nxy;   //!< nombre de bins total
+  float          xmin;  //!< abscisse minimum
+  float          xmax;  //!< abscisse maximum
+  float          ymin;  //!< ordonnee minimum
+  float          ymax;  //!< ordonnee maximum
+  float          wbinx; //!< largeur du bin en X
+  float          wbiny; //!< largeur du bin en Y
 
   bande_slice    b_s;
 
-  Histo*         hprojx;
-  Histo*         hprojy;
-
-  list<bande_slice>  lbandx;
-  list<bande_slice>  lbandy;
+  Histo*         hprojx; //!< pointer sur Histo des proj X
+  Histo*         hprojy; //!< pointer sur Histo des proj Y
+
+  list<bande_slice>  lbandx; //!< liste des bandes selon X
+  list<bande_slice>  lbandy; //!< liste des bandes selon Y
   
-  list<bande_slice>  lslix;
-  list<bande_slice>  lsliy;
+  list<bande_slice>  lslix; //!< liste des slices selon X
+  list<bande_slice>  lsliy; //!< liste des slices selon Y
 
 };
